/* Se da o matrice a[][] de numere intregi n x m
 * Sa se gaseasca suma maxima a unei submatrice a matricei a[][]
 * 
 * Complexitate : O(n^6) 
 * Algoritm naiv (de forta brut)
 */ 

#include <fstream>
#include <algorithm>
using namespace std;

ifstream fin("matrice.in");
ofstream fout("matrice.out");

const int Dim = 101, Inf = 1e9; // 1 miliard

int a[Dim][Dim];
int n, m;

int main()
{
	// citirea datelor de intrare
	fin >> n >> m;
	
	for (int i = 1; i <= n; ++i)
		for (int j = 1; j <= m; ++j)
			fin >> a[i][j];
			
	
	int s_max = -Inf;
	// generam toate submatricile 
	// Complexitate: O(n^6)
	for (int i1 = 1; i1 <= n; ++i1)
		for (int i2 = i1; i2 <= n; ++i2)
			for (int j1 = 1; j1 <= m; ++j1)
				for (int j2 = j1; j2 <= m; ++j2)
				{
					int s = 0;
					
					// parcurgem submatricea
					for (int i = i1; i <= i2; ++i)
						for (int j = j1; j <= j2; ++j)
							s += a[i][j];
							
					s_max = max(s_max, s);
				}
				
	fout << s_max;
}

