/* Se da o matrice a[][] de numere intregi n x m
 * Sa se gaseasca suma maxima a unei submatrice a matricei a[][]
 * 
 * Complexitate : O(n^6) 
 * Algoritm naiv (de forta brut)
 */ 

#include <fstream>
#include <algorithm>
using namespace std;

ifstream fin("matrice.in");
ofstream fout("matrice.out");

const int Dim = 302, Inf = 1e9; // 1 miliard

int a[Dim][Dim];
int n, m;

int main()
{
	// citirea datelor de intrare
	fin >> n >> m;
	
	for (int i = 1; i <= n; ++i)
		for (int j = 1; j <= m; ++j)
		{
			
			fin >> a[i][j];             
			a[i][j] += a[i - 1][j];
		}
		
	// Acum, a[i][j] reprezinta suma partiala pe coloana j, pana la linia i
			
	
	int s_max = -Inf;
	// generam toate submatricile 
	// Complexitate: O(n^3)
	for (int i1 = 1; i1 <= n; ++i1)
		for (int i2 = i1; i2 <= n; ++i2)
		{
			int s = 0;
			for (int j = 1; j <= m; ++j)
			{
				s += a[i2][j] - a[i1 - 1][j];
				
				if (s > s_max)
					s_max = s;
				if (s < 0)
					s = 0;
			}
		}
				
	fout << s_max;
}

